Index: /orxonox/trunk/src/lib/util/ini_parser.cc
===================================================================
--- /orxonox/trunk/src/lib/util/ini_parser.cc	(revision 5017)
+++ /orxonox/trunk/src/lib/util/ini_parser.cc	(revision 5018)
@@ -40,5 +40,5 @@
   this->sections = NULL;
   if (fileName != NULL)
-    this->openFile(fileName);
+    this->readFile(fileName);
 }
 
@@ -91,9 +91,7 @@
  * @return true on success false otherwise;
 */
-bool IniParser::openFile(const char* fileName)
+bool IniParser::readFile(const char* fileName)
 {
   FILE*    stream;           //!< The stream we use to read the file.
-
-
   if (sections != NULL)
     deleteSections();
@@ -101,4 +99,5 @@
     return false;
 
+  printf("1\n");
   if( (stream = fopen (fileName, "r")) == NULL)
   {
@@ -108,4 +107,5 @@
   else
   {
+    printf("2\n");
     this->currentEntry = NULL;
     this->currentSection = NULL;
@@ -119,14 +119,16 @@
     char* ptr;
 
-    rewind (stream);
     while( !feof( stream))
     {
       // get next line
       fgets (lineBuffer, PARSELINELENGHT, stream);
+      printf("%s", lineBuffer);
       // remove newline char, and \0-terminate
       if( (ptr = strchr( lineBuffer, '\n')) != NULL)
         *ptr = 0;
       // check for section identifyer
-      if( sscanf (lineBuffer, "[%s", buffer) == 1)
+      if (strlen(lineBuffer) <= 1)
+        printf("empty Line\n");
+      else if( sscanf (lineBuffer, "[%s", buffer) == 1)
       {
         if( (ptr = strchr( buffer, ']')) != NULL)
@@ -137,8 +139,9 @@
           strcpy(newSection->name, buffer);
           newSection->entries = new tList<IniEntry>;
+          this->currentSection = newSection;
           this->sections->add(newSection);
-          this->currentSection = newSection;
         }
       }
+      // check for Entry identifier (Entry = Value)
       else if( (ptr = strchr( lineBuffer, '=')) != NULL)
       {
@@ -150,18 +153,19 @@
         if( ptr == lineBuffer)
           continue;
-        IniEntry* newEntry = new IniEntry;
-
         char* valueBegin = ptr+1;
         while ((*valueBegin == ' ' || *valueBegin == '\t') && valueBegin <= lineBuffer + strlen(lineBuffer))
           ++valueBegin;
-        newEntry->value = new char[strlen(valueBegin)+1];
-        strcpy(newEntry->value, valueBegin);
-        char* nameEnd = ptr-1, *nameBegin = lineBuffer;
+        char* nameBegin = lineBuffer;
         while ((*nameBegin == ' ' || *nameBegin == '\t') && nameBegin < ptr)
           ++nameBegin;
+        char* nameEnd = ptr-1;
         while ((*nameEnd == ' ' || *nameEnd == '\t' ) && nameEnd >= nameBegin)
           --nameEnd;
         nameEnd[1] = '\0';
-        newEntry->name = new char[strlen (nameBegin)];
+
+        IniEntry* newEntry = new IniEntry;
+        newEntry->value = new char[strlen(valueBegin)+1];
+        strcpy(newEntry->value, valueBegin);
+        newEntry->name = new char[strlen (nameBegin)+1];
         strcpy(newEntry->name, nameBegin);
 
Index: /orxonox/trunk/src/lib/util/ini_parser.h
===================================================================
--- /orxonox/trunk/src/lib/util/ini_parser.h	(revision 5017)
+++ /orxonox/trunk/src/lib/util/ini_parser.h	(revision 5018)
@@ -42,5 +42,5 @@
     ~IniParser ();
 
-    bool openFile(const char* name);
+    bool readFile(const char* name);
 
     bool getSection(const char* sectionName);
Index: /orxonox/trunk/src/orxonox.cc
===================================================================
--- /orxonox/trunk/src/orxonox.cc	(revision 5017)
+++ /orxonox/trunk/src/orxonox.cc	(revision 5018)
@@ -139,6 +139,6 @@
 
   // initialize the Config-file
+  printf("wet\n");
   this->getConfigFile();
-
 
   // initialize everything
@@ -375,4 +375,5 @@
     }
 
+    printf("finished inizialisation\n");
   orx->start();
 
Index: /orxonox/trunk/src/orxonox.h
===================================================================
--- /orxonox/trunk/src/orxonox.h	(revision 5017)
+++ /orxonox/trunk/src/orxonox.h	(revision 5018)
@@ -1,5 +1,5 @@
 /*!
-    \file orxonox.h
-  *  Orxonox core functions
+ * @file orxonox.h
+ * Orxonox core functions
 */
 