Index: orxonox/trunk/src/lib/graphics/graphics_engine.cc
===================================================================
--- orxonox/trunk/src/lib/graphics/graphics_engine.cc	(revision 5023)
+++ orxonox/trunk/src/lib/graphics/graphics_engine.cc	(revision 5024)
@@ -115,10 +115,10 @@
   if (this->isInit)
     return -1;
-  // initialize SDL_VIDEO
+  //   initialize SDL_VIDEO
   if (SDL_Init(SDL_INIT_VIDEO) == -1)
-    {
-      PRINTF(1)("could not initialize SDL Video\n");
+  {
+    PRINTF(1)("could not initialize SDL Video\n");
       //      return -1;
-    }
+  }
   // initialize SDL_GL-settings
   this->setGLattribs();
@@ -145,9 +145,4 @@
   this->setResolution(resX, resY, bbp);
 
-  // TO DO: Create a cool icon and use it here
-  char* loadPic = new char[strlen(ResourceManager::getInstance()->getDataDir())+ 100];
-  sprintf(loadPic, "%s%s", ResourceManager::getInstance()->getDataDir(),  "pictures/orxonox-icon32x32.bmp");
-  SDL_WM_SetIcon(SDL_LoadBMP(loadPic), NULL);
-  delete loadPic;
   // Enable default GL stuff
   glEnable(GL_DEPTH_TEST);
@@ -165,5 +160,6 @@
 void GraphicsEngine::setWindowName(const char* windowName, const char* icon)
 {
-  // Set window labeling
+  SDL_WM_SetIcon(SDL_LoadBMP(icon), NULL);
+
   SDL_WM_SetCaption (windowName, icon);
 }
Index: orxonox/trunk/src/lib/gui/gui_exec.h
===================================================================
--- orxonox/trunk/src/lib/gui/gui_exec.h	(revision 5023)
+++ orxonox/trunk/src/lib/gui/gui_exec.h	(revision 5024)
@@ -1,6 +1,6 @@
 /*!
-  \file gui_exec.h
-  \brief File that holds the class that creates the execute-Options.
-*/
+ * file gui_exec.h
+ * File that holds the class that creates the execute-Options.
+ */
 
 #ifndef _GUI_EXEC_H
Index: orxonox/trunk/src/lib/gui/gui_gtk.h
===================================================================
--- orxonox/trunk/src/lib/gui/gui_gtk.h	(revision 5023)
+++ orxonox/trunk/src/lib/gui/gui_gtk.h	(revision 5024)
@@ -1,6 +1,6 @@
 /*!
- \file gui_gtk.h
- \brief Contains all th different Widgets.
-*/
+ * @file gui_gtk.h
+ * Contains all th different Widgets.
+ */
 #ifndef _GUI_GTK_H
 #define _GUI_GTK_H
@@ -33,12 +33,15 @@
 
 // enumerator for different GuiOption-Types
-enum GUI_OPTION {GUI_BOX = -2,
-                 GUI_CONTAINER = -1,
-                 GUI_NOTHING = 0,
-                 GUI_BOOL = 1,
-                 GUI_INT = 2,
-                 GUI_FLOAT = 3,
-                 GUI_CHAR = 4,
-                 GUI_CHAR_ARRAY = 5};
+enum GUI_OPTION
+{
+  GUI_BOX = -2,
+  GUI_CONTAINER = -1,
+  GUI_NOTHING = 0,
+  GUI_BOOL = 1,
+  GUI_INT = 2,
+  GUI_FLOAT = 3,
+  GUI_CHAR = 4,
+  GUI_CHAR_ARRAY = 5
+};
 
 extern char* executable;
Index: orxonox/trunk/src/lib/gui/gui_video.cc
===================================================================
--- orxonox/trunk/src/lib/gui/gui_video.cc	(revision 5023)
+++ orxonox/trunk/src/lib/gui/gui_video.cc	(revision 5024)
@@ -223,4 +223,5 @@
       }
   }
+  SDL_QuitSubSystem(SDL_INIT_VIDEO);
   SDL_Quit();
 }
Index: orxonox/trunk/src/orxonox.cc
===================================================================
--- orxonox/trunk/src/orxonox.cc	(revision 5023)
+++ orxonox/trunk/src/orxonox.cc	(revision 5024)
@@ -160,8 +160,10 @@
 
   GraphicsEngine::getInstance();
-  GraphicsEngine::getInstance()->setWindowName(PACKAGE_NAME " " PACKAGE_VERSION, PACKAGE_NAME " " PACKAGE_VERSION);
 
   GraphicsEngine::getInstance()->initFromIniFile(this->iniParser);
 
+  char* icon = ResourceManager::getFullName("pictures/fighter-top-32x32.bmp");
+  GraphicsEngine::getInstance()->setWindowName(PACKAGE_NAME " " PACKAGE_VERSION, icon);
+  delete icon;
   return 0;
 }
Index: orxonox/trunk/src/orxonox.h
===================================================================
--- orxonox/trunk/src/orxonox.h	(revision 5023)
+++ orxonox/trunk/src/orxonox.h	(revision 5024)
@@ -54,6 +54,7 @@
 
 
-
-
+////////////////////////
+// Start-up functions //
+////////////////////////
 int startHelp(int argc, char** argv);
 int startOrxonox(int argc, char** argv);