Index: orxonox/trunk/src/lib/collision_detection/obb_tree_node.cc
===================================================================
--- orxonox/trunk/src/lib/collision_detection/obb_tree_node.cc	(revision 5028)
+++ orxonox/trunk/src/lib/collision_detection/obb_tree_node.cc	(revision 5029)
@@ -651,5 +651,6 @@
       if( unlikely(this->nodeRight == NULL && this->nodeLeft == NULL))
       {
-        //nodeA->collidesWith()
+        nodeA->collidesWith(nodeB);
+        nodeB->collidesWith(nodeA);
       }
     }
Index: orxonox/trunk/src/subprojects/collision_detection/collision_detection.cc
===================================================================
--- orxonox/trunk/src/subprojects/collision_detection/collision_detection.cc	(revision 5028)
+++ orxonox/trunk/src/subprojects/collision_detection/collision_detection.cc	(revision 5029)
@@ -82,11 +82,11 @@
 
 //   a = new TestEntity(); a->setName("Clown1");
-//   b = new Environment(); b->setName("Jaeger");
-  a = new Terrain();
+   b = new Environment(); b->setName("Jaeger");
+//   a = new Terrain();
 
 //   b->setRelCoor(0.0, 0.0, -20.0);
 //   b->setRelDir(Quaternion(-M_PI/2.0f, Vector(0.0, 1.0, 0.0)));
 
-  entityList->add(a);
+  entityList->add(b);
 //   entityList->add(b);
 
Index: orxonox/trunk/src/world_entities/environment.cc
===================================================================
--- orxonox/trunk/src/world_entities/environment.cc	(revision 5028)
+++ orxonox/trunk/src/world_entities/environment.cc	(revision 5029)
@@ -33,5 +33,5 @@
 {
   this->setClassID(CL_ENVIRONMENT, "Environment");
-  this->model = (Model*)ResourceManager::getInstance()->load("models/reaplow.obj"/*"worlds/vulcania.obj"*/, OBJ, RP_CAMPAIGN);
+  this->model = (Model*)ResourceManager::getInstance()->load("models/bolido.obj", OBJ, RP_CAMPAIGN);
 
   this->obbTree = new OBBTree(15, (sVec3D*)this->model->getVertexArray(), this->model->getVertexCount());
Index: orxonox/trunk/src/world_entities/npc.cc
===================================================================
--- orxonox/trunk/src/world_entities/npc.cc	(revision 5028)
+++ orxonox/trunk/src/world_entities/npc.cc	(revision 5029)
@@ -37,11 +37,9 @@
 
 
+void NPC::collidesWith(WorldEntity* entity, const Vector& location)
+{
 
-/* define the reaction, if the ship is been hit */
-int NPC::hit()
-{
-  die();
-  return 0;
 }
+
 
 void NPC::tick(float dt)
@@ -55,5 +53,2 @@
 
 
-void NPC::die()
-{
-}
Index: orxonox/trunk/src/world_entities/npc.h
===================================================================
--- orxonox/trunk/src/world_entities/npc.h	(revision 5028)
+++ orxonox/trunk/src/world_entities/npc.h	(revision 5029)
@@ -16,10 +16,11 @@
   void addAI(AI* ai);
 
-  void tick(float dt);
-  int hit();
-  void die();
+  virtual void tick(float dt);
+
+  virtual void collidesWith (WorldEntity* entity, const Vector& location);
+
 
  private:
-  /* position of the non player space craft */
+
 ;
 
Index: orxonox/trunk/src/world_entities/world_entity.cc
===================================================================
--- orxonox/trunk/src/world_entities/world_entity.cc	(revision 5028)
+++ orxonox/trunk/src/world_entities/world_entity.cc	(revision 5029)
@@ -103,7 +103,20 @@
 void WorldEntity::collidesWith(WorldEntity* entity)
 {
-  //this->obbTree->collideWith(entity->obbTree, (PNode*)this, (PNode*)entity);
-}
-
+  //this->obbTree->collideWith(entity->obbTree, (PNode*)this, (PNode*)entity);]
+  PRINTF(0)("COLLISION ---------------------------- with object: %s\n", entity->getName());
+}
+
+
+/**
+ *  this function is called, when two entities collide
+ * @param entity: the world entity with whom it collides
+ *
+ * Implement behaviour like damage application or other miscellaneous collision stuff in this function
+ */
+void WorldEntity::collidesWith(WorldEntity* entity, const Vector& location)
+{
+  //this->obbTree->collideWith(entity->obbTree, (PNode*)this, (PNode*)entity);]
+  PRINTF(0)("COLLISION ---------------------------- with object: %s\n", entity->getName());
+}
 
 /**
Index: orxonox/trunk/src/world_entities/world_entity.h
===================================================================
--- orxonox/trunk/src/world_entities/world_entity.h	(revision 5028)
+++ orxonox/trunk/src/world_entities/world_entity.h	(revision 5029)
@@ -52,4 +52,5 @@
   virtual void hit (WorldEntity* weapon, Vector* loc);
   virtual void collidesWith (WorldEntity* entity);
+  virtual void collidesWith (WorldEntity* entity, const Vector& location);
 
   /** @returns the Count of Faces on this WorldEntity */